<template>
  <div>
    <el-form ref="queryForm" :model="searchForm" label-width="0" inline>
      <el-form-item>
        <el-input
          v-model="searchForm.name"
          placeholder="请输入名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery">搜索</el-button>
        <el-button @click="resetQuery">重置</el-button>
        <el-button type="primary" @click="openForm('create', null)">新增</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="tableList">
      <el-table-column prop="label" label="费用项" />
      <el-table-column prop="sort" label="排序" width="100px" />
      <el-table-column prop="remark" label="备注" />
      <el-table-column
        label="创建时间"
        prop="createTime"
        width="180px"
        :formatter="dateFormatter"
      />
      <el-table-column label="操作">
        <template #default="scope">
          <el-button
            type="primary"
            :disabled="!scope.row.editable"
            text
            @click="openForm('update', scope.row.id)"
          >
            修改
          </el-button>
          <el-button
            type="danger"
            :disabled="!scope.row.editable"
            text
            @click="handleDelete(scope.row.id)"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <Pagination
      v-model:limit="searchForm.pageSize"
      v-model:page="searchForm.pageNo"
      :total="total"
      @pagination="getList"
    />

    <DialogOtherPay ref="otherOayDialog" @success="handleQuery" />
  </div>
</template>

<script setup name="OtherPayType">
import { dateFormatter } from '@/utils/formatTime'
import DialogOtherPay from './DialogOtherPay.vue'
import * as dictApi from '@/api/system/dict/dict.data'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const searchForm = ref({
  label: '',
  pageSize: 20,
  pageNo: 1,
  dictType: 'other_pay_type'
})

const total = ref(0)
const otherOayDialog = ref()
const tableList = ref([])
const loading = ref(false)

function handleQuery() {
  searchForm.value.pageNo = 1
  getList()
}
function resetQuery() {
  searchForm.value = {
    label: '',
    pageSize: 20,
    pageNo: 1,
    dictType: 'other_pay_type'
  }
  getList()
}

async function getList() {
  loading.value = true
  try {
    const data = await dictApi.getDictDataPage(searchForm.value)
    tableList.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

function openForm(type, id) {
  otherOayDialog.value.open(type, id)
}

async function handleDelete(id) {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await dictApi.deleteDictData(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

onMounted(() => {
  handleQuery()
})
</script>

<style lang="scss" scoped></style>
